p=genpath('.');
addpath(p);

v1_folder = './data1/v1';% frames extracted from video and optical flow result for each frame
v1_outfolder = './data1/v1_out';
v2_folder = './data1/v2';
v2_outfolder = './data1/v2_out'; 

v_index_folder = './index'; % index files which record the position(x,y,t) and index of extracted hog3d feature from videos


movingcue(v1_folder,v1_outfolder,1); %1: gray video, 0: color video
movingcue(v2_folder,v2_outfolder,1);  %getting the weight map for each frame

extractfeature(v_index_folder, 'vis_feas.mat',0); %extract weighted bag of words

generate_actoms('vis_feas.mat'); %time series clustering for actom discovery

co_action; % the label for each actoms



%make videos for results
load co_action_result.mat
index1 = 0;
index2 = 0;
for i = 2:length(frames)
    if frames(i)<frames(i-1)
        index1 = i;
        break;
    end
end
for i = 2:length(frames1)
    if frames1(i)<frames1(i-1)
        index2 = i;
        break;
    end
end
aviobj1 = avifile('result1.avi');
aviobj2 = avifile('result2.avi');

%// the quality of this video file
aviobj1.Quality = 80;
%// compression method. See matlab manual for details.
aviobj1.COMPRESSION ='None';%%color image

for i =1:length(frames)
     if i < index1
         str = sprintf('%s/%05d.png',v1_folder,frames(i));
     else
         str = sprintf('%s/%05d.png',v2_folder,frames(i));
     end
     image = imread(str);
         
     aviobj1 = addframe(aviobj1,image);
end
aviobj1 = close(aviobj1);

%// the quality of this video file
aviobj2.Quality = 80;
%// compression method. See matlab manual for details.
aviobj2.COMPRESSION ='None';%%color image

for i =1:length(frames1)
     if i < index2
         str = sprintf('%s/%05d.png',v1_folder,frames1(i));
     else
         str = sprintf('%s/%05d.png',v2_folder,frames1(i));
     end
     image = imread(str);
         
     aviobj2 = addframe(aviobj2,image);
end
aviobj2 = close(aviobj2);